import java.util.*;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;


//-----------------------------------------------------
class DrawCanvas 
extends JComponent {
        // For more colors just add more to the list
        //Color.black, Color.blue ,Color.cyan,Color.darkGray,Color.green,Color.lightGray,
        //Color.magenta,Color.orange,Color.pink,Color.red, Color.white,Color.yellow}
        
        static Color[] colors={
        // these RGB colors came straight from Laurens Lapre's 'setup1.pov'
        	new Color((float)0.8,       (float)0.498039,  (float)0.196078),
		new Color((float)0.5 ,      (float)0.5,       (float)0.5),
		new Color((float)1.0,       (float)0.0,       (float)0.0),
		new Color((float)1.0,       (float)1.0,       (float)0.0),
		new Color((float)0.2,       (float)0.7,       (float)0.1),
		new Color((float)0.0,       (float)1.0,       (float)1.0),
		new Color((float)0.0,       (float)0.0,       (float)1.0),
		new Color((float)1.0,       (float)0.0,       (float)1.0),
		new Color((float)0.439216,  (float)0.858824,  (float)0.576471),
		new Color((float)1.0 ,      (float)0.498039 , (float)0.0),
		new Color((float)0.258824 , (float)0.258824 , (float) 0.435294),
		new Color((float)0.6 ,      (float)0.196078 , (float)0.8),
		new Color((float)0.439216 , (float)0.576471 , (float)0.858824),
		new Color((float)0.556863 , (float) 0.137255 ,(float)0.137255),
		new Color((float)0.858824 , (float)0.858824 , (float) 0.439216),
		new Color((float)0.623529 , (float)0.623529 , (float)0.372549),
		Color.white//,
		//Color.black
        };                        
        private int numColors=colors.length;
        
	private Vector lines; 
                      
	final int XYProj=0,
	          YZProj=1,
	          ZXProj=2;
	private int curProjection=XYProj;
        
        public DrawCanvas() {            
            
            lines=new Vector();
            //setBackground(new Color(255,255,255));
            setBackground(new Color(0,0,0));
            setOpaque(true);
       	}
  	
  	void drawLines(Graphics g){
        
            int sz=lines.size();
  	    
  	    
  	    
       	    for(int i=0;i<sz;i++){
       	    	//System.out.print("+");
       	    	((LineObject)lines.get(i)).draw(g);
       	    	
       	    }
       	    //System.out.println("*");
       	     	
        }
  	public void reDraw(){
  	    int w=getWidth(),
                h=getHeight(); 
        
            Graphics g=getGraphics();
            g.setColor(getBackground());
            g.fillRect(0,0,w,h);
            drawLines(g);
  	}
  	public void paint(Graphics g){
  	    int w=getWidth(),
                h=getHeight(); 
        
            
            g.setColor(getBackground());
            g.fillRect(0,0,w,h);
            drawLines(g);
  	}
  	void setProjection(int proj){
  		curProjection=proj;
  	}
  	void makeNewLine(double x1,double y1,double z1,double x2,double y2,double z2,int color){
  	       lines.addElement(new LineObject(x1,y1,z1,x2,y2,z2,color));
  	}
        void drawline(double x1,double y1,double z1,double x2,double y2,double z2,int color){
                
          	LineObject lE=new LineObject(x1,y1,z1,x2,y2,z2,color);
       		
       		lines.addElement(lE);
       		
       		lE.draw(getGraphics());
       
        }
  
          // for layout manager
        public Dimension getPreferredSize() {
            return new Dimension(200,200);
        }
        public Dimension getMinimumSize() {
            return getPreferredSize();
        }
        public Dimension getMaximumSize() {
            return getPreferredSize();
        }
        void clearLines(){
        	lines.removeAllElements();
        }
        class LineObject{
        // *all* LMUSe draws is lines
        	double x1,y1,z1,x2,y2,z2;
        	int color;
        	public LineObject(double xs,double ys,double zs,double xe,double ye,double ze,int c){	
        		x1=xs;y1=ys;z1=zs;
        		x2=xe;y2=ye;z2=ze;
        		color=c;
        	
        	}
        	void draw(Graphics g){

                        if(g==null) return;
                        
                        int w=getWidth();
                 	int h=getHeight();
                 	double sc=(w>h)?h:w; //scale to the smaller dimension
                 	double border=.05;
                        int ix1,ix2,iy1,iy2,iz1,iz2;
                        sc*=(1-2*border);/* to leave some space around the border */
                       
                 	double x1s=x1+border;
                 	double y1s=y1+border;
                 	double z1s=z1+border;
                 	double x2s=x2+border;
                 	double y2s=y2+border;
                 	double z2s=z2+border;
                 	
                 	
                        switch(curProjection){
                           default:
                           
                           case XYProj:
                                ix1=(int) (sc*x1s);
                                iy1=(int) (sc*y1s);
                                ix2=(int) (sc*x2s);
                                iy2=(int) (sc*y2s);
                                break; 
                           case YZProj:
                                ix1=(int) (sc*y1s);
                        	iy1=(int) (sc*z1s);
                        	ix2=(int) (sc*y2s);
                        	iy2=(int) (sc*z2s);
                        	break;
                           case ZXProj:
                        	ix1=(int) (sc*z1s);
                        	iy1=(int) (sc*x1s);
                        	ix2=(int) (sc*z2s);
                        	iy2=(int) (sc*x2s);
                                break;
                            
                        }
                       
                        
                        g.setColor(colors[color%numColors]);
                  	g.drawLine(ix1,iy1,ix2,iy2);
        		
        	}
        }
   
}

class DrawFrame 
extends JInternalFrame 
implements ActionListener{
	private DrawCanvas drawcanvas;
	private JButton xyProjB,yzProjB,zxProjB;
	
	public DrawFrame(String title){
		//super(title,true,false,false,false);
		super(title,true,false,false,true);
		drawcanvas=new DrawCanvas();
		
		getContentPane().setLayout(new BorderLayout());	
		getContentPane().add(drawcanvas,BorderLayout.CENTER);
		
		JPanel bPanel=new JPanel();
		xyProjB=new JButton("xy");
		xyProjB.addActionListener(this);
		yzProjB=new JButton("yz");
		yzProjB.addActionListener(this);
		zxProjB=new JButton("zx");
		zxProjB.addActionListener(this);
		
		xyProjB.setBackground(Color.pink);
	        yzProjB.setBackground(Color.lightGray);
	        zxProjB.setBackground(Color.lightGray);
		
		bPanel.add(xyProjB);
		bPanel.add(yzProjB);
		bPanel.add(zxProjB);

		getContentPane().add(bPanel,BorderLayout.SOUTH);

	}
	DrawCanvas getCanvas(){
		return drawcanvas;
	}
	void clear(){
		drawcanvas.clearLines();
	}
	public void actionPerformed(ActionEvent e) {
	        Object esource=e.getSource();
	        
	 	if(esource==xyProjB){
	 		drawcanvas.setProjection(drawcanvas.XYProj);
	 		xyProjB.setBackground(Color.pink);
	 		yzProjB.setBackground(Color.lightGray);
	 		zxProjB.setBackground(Color.lightGray);
	 		drawcanvas.reDraw();
	 		
	 	}
	 	else if(esource==yzProjB){
	 		drawcanvas.setProjection(drawcanvas.YZProj);
	 		xyProjB.setBackground(Color.lightGray);
	 		yzProjB.setBackground(Color.pink);
	 		zxProjB.setBackground(Color.lightGray);
	 		drawcanvas.reDraw();
	 	}
	 	else if(esource==zxProjB){
	 		drawcanvas.setProjection(drawcanvas.ZXProj);
	 		xyProjB.setBackground(Color.lightGray);
	 		yzProjB.setBackground(Color.lightGray);
	 		zxProjB.setBackground(Color.pink);
	 		drawcanvas.reDraw();
	 	}

	} 

}