import java.util.*;
import java.io.*;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

import java.net.URL; // for finding the icons and help text.

class LMUSe {

        public static void main(String[] args) {
        	/*
    		String metalClassName = "javax.swing.plaf.metal.MetalLookAndFeel";
    		
    		String motifClassName = 
	    		"com.sun.java.swing.plaf.motif.MotifLookAndFeel";
    		
    		String windowsClassName = 
	    		"com.sun.java.swing.plaf.windows.WindowsLookAndFeel";
		try {
	          UIManager.setLookAndFeel(motifClassName);
	      	} catch (Exception exc) {
	          System.err.println("Error loading L&F: " + exc);
	      	}
	      	*/
                new MainFrame();
                           
        }
        
}       
 
class MainFrame extends JFrame implements ActionListener{   

        private JMenuBar menuBar;
        private JMenu fileMenu;
        private JMenu helpMenu;
        private JMenu optionsMenu;
        private JMenuItem instrumentsToTracksMenuItem;
        private JMenuItem LMUSeInfoMenuItem;
        
        private JMenuItem loadRulefileMenuItem; 
        private JMenuItem saveRulefileMenuItem;
        private JMenuItem loadMapfileMenuItem;
        private JMenuItem saveMapfileMenuItem;        
        private JMenuItem loadRuleAndMapfileMenuItem;
        private JMenuItem saveRuleAndMapfileMenuItem;                
        private JMenuItem saveMIDIfileMenuItem;       
        private File curDir;
        private String curDirName;
         
        
        
        private LFileReaderWriter ruleFileReaderWriter=new LFileReaderWriter(new ExampleFileFilter(
                           new String[]{"ls","lm","l","lg","rwm"}, "LMUSe Rule files"),"l"){
        	boolean myReader(File f){
        		return readRuleFile(f);
        	}
        	boolean myWriter(File f){
        		return saveRuleFile(f);
        	}

        	void followup(){
        		productionframe.setTitle("Production  "+mylastopen.getName());	
        	}
        };
        private LFileReaderWriter mapFileReaderWriter=new LFileReaderWriter(new ExampleFileFilter(
                           new String[]{"map","ini"}, "LMUSe Map files"),"map"){
        	boolean myReader(File f){
        		return readMapFile(f);
        	}
        	boolean myWriter(File f){
        		return writeMapFile(f);
        	}
        	void followup(){}
        };
        private LFileReaderWriter ruleAndMapFileReaderWriter=new LFileReaderWriter(new ExampleFileFilter(
                           new String[]{"lg","rwm","ls","l","lm"}, "LMUSe Rule w/ Map files"),"rwm"){
        	boolean myReader(File f){
        		return readRuleAndMapFile(f);
        	}
        	boolean myWriter(File f){
        		return writeRuleAndMapFile(f);
        	}
        	void followup(){
        		productionframe.setTitle("Production  "+mylastopen.getName());	
        	}
        };
        private LFileReaderWriter MIDIFileWriter=new LFileReaderWriter(new ExampleFileFilter(
                           new String[]{"mid"}, "MIDI files"),"mid"){
                boolean myReader(File f){
                        // filler
                        return false;
                }
        	boolean myWriter(File f){
        		return writeMIDIFile(f);
        	}
        	void followup(){}
        };
        
        private JMenuItem symbolsHelpMenuItem;
        private JMenuItem instrumentsHelpMenuItem; 
        
        String fileText;
        
        JDesktopPane desktop;
        // these frames get passed around
        ProductionFrame productionframe;
        InterpretFrame interpretframe;
        MIDIFrame midiframe;
        DrawFrame drawframe;
        
        /***/
        JButton PButton,IButton,DButton,MButton;
        /***/
        int numRecursions=1;
        double basicAngle=0.0;        
        double basicThickness=10.0;
        
        public MainFrame(){
        
        	super("LMUSe");
		setSize(760, 500);// too big for 640X480!
		/***/
		getContentPane().setLayout(new BorderLayout());
		/***/                
                
                 /***/
                JToolBar focusToolBar=new JToolBar();
                
                JButton PButton,IButton,DButton,MButton;
                
                URL url;
                url=getClass().getResource("Icons/P.gif");
                
                if(url==null){
                	PButton = new JButton(new ImageIcon("Icons/P.gif"));                
                }
                else{
                	PButton = new JButton(new ImageIcon(url));
                	//System.out.println(url.toString());
                }
                PButton.setToolTipText("Bring Production frame to the front");
                
                url=getClass().getResource("Icons/I.gif"); 
                if(url==null)
                	IButton = new JButton(new ImageIcon("Icons/I.gif"));
                else
                	IButton = new JButton(new ImageIcon(url));
                IButton.setToolTipText("Bring Interpretation frame to the front");
                
                url=getClass().getResource("Icons/Bop01.gif"); 
                if(url==null)
                	DButton = new JButton(new ImageIcon("Icons/Bop01.gif"));
                else
                	DButton = new JButton(new ImageIcon(url));                
                DButton.setToolTipText("Bring Drawing frame to the front");
                
                url=getClass().getResource("Icons/qnote.gif"); 
                if(url==null)
                	MButton = new JButton(new ImageIcon("Icons/qnote.gif"));
                else
                	MButton = new JButton(new ImageIcon(url));
                MButton.setToolTipText("Bring MIDI frame to the front");
                
                PButton.addActionListener(new ActionListener() {
            		  public void actionPerformed(ActionEvent e) {
            		        if(productionframe.isIcon()){
				  try{
                   			productionframe.setIcon(false);
                   			
                		  }catch (Exception ex){}
                		}
				productionframe.toFront();
				try{
                   		
                   			productionframe.setSelected(true);
                		}catch (Exception ex){}
            		  }
        	        });
                IButton.addActionListener(new ActionListener() {
            		  public void actionPerformed(ActionEvent e) {
            		        if(interpretframe.isIcon()){
				  try{
                   			interpretframe.setIcon(false);
                   			
                		  }catch (Exception ex){}
                		}
				interpretframe.toFront();
				try{
                   		
                   			interpretframe.setSelected(true);
                		}catch (Exception ex){}
            		  }
        	        });
        	DButton.addActionListener(new ActionListener() {
            		  public void actionPerformed(ActionEvent e) {
            		        if(drawframe.isIcon()){
				  try{
                   			drawframe.setIcon(false);
                   			
                		  }catch (Exception ex){}
                		}
				drawframe.toFront();
				try{
                   		
                   			drawframe.setSelected(true);
                		}catch (Exception ex){}
            		  }
        	        });

                MButton.addActionListener(new ActionListener() {
            		  public void actionPerformed(ActionEvent e) {
            		        if(midiframe.isIcon()){
				  try{
                   			midiframe.setIcon(false);
                   			
                		  }catch (Exception ex){}
                		}
				midiframe.toFront();
				try{
                   		
                   			midiframe.setSelected(true);
                		}catch (Exception ex){}
            		  }
        	        });

                focusToolBar.add(PButton);
                focusToolBar.add(IButton);
                focusToolBar.add(DButton);
                focusToolBar.add(MButton);

                //focusToolBar.setFloatable(false);
                focusToolBar.setOrientation(JToolBar.VERTICAL);
                getContentPane().add(focusToolBar,BorderLayout.EAST);
                /***/
                desktop = new JDesktopPane();
                //getContentPane().add(desktop);
                getContentPane().add(desktop,BorderLayout.CENTER);
                
                menuBar = new JMenuBar();
                setJMenuBar(menuBar);
                fileMenu = new JMenu("File");
                fileMenu.setMnemonic(KeyEvent.VK_F);
                menuBar.add(fileMenu);
                loadRulefileMenuItem= new JMenuItem("Load Rule File",KeyEvent.VK_L);
                loadRulefileMenuItem.addActionListener(this);
                fileMenu.add(loadRulefileMenuItem);		

                saveRulefileMenuItem= new JMenuItem("Save Rule File",KeyEvent.VK_S);
                saveRulefileMenuItem.addActionListener(this);
                fileMenu.add(saveRulefileMenuItem);		
                
		fileMenu.add(new JMenuItem(""));
				
                loadMapfileMenuItem= new JMenuItem("Load Map File",KeyEvent.VK_O);
                loadMapfileMenuItem.addActionListener(this);
                fileMenu.add(loadMapfileMenuItem);		

                saveMapfileMenuItem= new JMenuItem("Save Map File",KeyEvent.VK_A);
                saveMapfileMenuItem.addActionListener(this);
                fileMenu.add(saveMapfileMenuItem);
                
		fileMenu.add(new JMenuItem(""));
		
		loadRuleAndMapfileMenuItem= new JMenuItem("Load Rule w/Map File",KeyEvent.VK_D);
                loadRuleAndMapfileMenuItem.addActionListener(this);
                fileMenu.add(loadRuleAndMapfileMenuItem);		

                saveRuleAndMapfileMenuItem= new JMenuItem("Save Rule w/Map File",KeyEvent.VK_V);
                saveRuleAndMapfileMenuItem.addActionListener(this);
                fileMenu.add(saveRuleAndMapfileMenuItem);
                
		fileMenu.add(new JMenuItem(""));
		
		saveMIDIfileMenuItem= new JMenuItem("Save MIDI File",KeyEvent.VK_M);
                saveMIDIfileMenuItem.addActionListener(this);
                fileMenu.add(saveMIDIfileMenuItem);

                optionsMenu= new JMenu("Options");
                optionsMenu.setMnemonic(KeyEvent.VK_O);
                menuBar.add(optionsMenu);
                instrumentsToTracksMenuItem=new JMenuItem("Save Instruments on Separate Tracks");
                instrumentsToTracksMenuItem.addActionListener(this);
                optionsMenu.add(instrumentsToTracksMenuItem);                
                helpMenu = new JMenu("Help");
                helpMenu.setMnemonic(KeyEvent.VK_H);
                menuBar.add(helpMenu);
                
                
                
                symbolsHelpMenuItem= new JMenuItem("Symbol Alphabet",KeyEvent.VK_A);
                symbolsHelpMenuItem.addActionListener(this);
                helpMenu.add(symbolsHelpMenuItem);
                
                instrumentsHelpMenuItem= new JMenuItem("Instrument Numbers",KeyEvent.VK_I);
                instrumentsHelpMenuItem.addActionListener(this);
                helpMenu.add(instrumentsHelpMenuItem);
                
                
                
                LMUSeInfoMenuItem=new JMenuItem("LMUSe Info",KeyEvent.VK_L);
                LMUSeInfoMenuItem.addActionListener(this);
                helpMenu.add(LMUSeInfoMenuItem);

                
                /*
		String Axiom="c(20)F+F+F+F";
                String rtxt="F=FFFF-F+F+F-F[-f{FF+F+FF+F}]FF"+"\n"
                           +"f='8f'.125c"
                           ;
                */
                String Axiom="";
                String rtxt="";
		productionframe=new ProductionFrame(Axiom,"",rtxt);
                desktop.add(productionframe);
                productionframe.setVisible(true);
                
                
                
                midiframe=new MIDIFrame("MIDI");
                midiframe.setLocation(new Point(200,60));                                
                midiframe.setVisible(true);                
                desktop.add(midiframe);
                try{
                   midiframe.setIcon(true);
                }catch (Exception e){
                       // does it matter if this fails?
                }

                drawframe=new DrawFrame("Drawing");
                drawframe.setLocation(new Point(0,60));                
                drawframe.setSize(200,250);
                drawframe.setVisible(true);
                desktop.add(drawframe);

                try{
                // Let drawframe be "open" by default
                   //drawframe.setIcon(true);
                }catch (Exception e){}
                
                interpretframe=new InterpretFrame(productionframe,drawframe,midiframe);
                interpretframe.setLocation(new Point(0,30));//put it somewhere
                interpretframe.setVisible(true);                                
                desktop.add(interpretframe);
                try{
                   interpretframe.setIcon(true);
                }catch (Exception e){}
                
               
                addWindowListener(new WindowAdapter() {
                    public void windowClosing(WindowEvent e) {
                        exitstuff(); 
			System.exit(0);
                    }
                });
                 
                desktop.setVisible(true);
                
                //pack();/***/
                setVisible(true);

                curDirName=System.getProperty("user.dir");
                curDir=new File(curDirName);

	}
	
	void exitstuff(){
	         writeRuleAndMapFile(new File("last.lg"));         
	}
	
	
	public void actionPerformed(ActionEvent e) {
	        Object esource=e.getSource();
	        
	 	if(esource==loadRulefileMenuItem){
	 	    ruleFileReaderWriter.doFileAction(READ);
                }
                else if(esource==saveRulefileMenuItem){
                    ruleFileReaderWriter.doFileAction(WRITE);
                }
                else if(esource==loadMapfileMenuItem){
                    mapFileReaderWriter.doFileAction(READ);
                }
                else if(esource==saveMapfileMenuItem){
                    mapFileReaderWriter.doFileAction(WRITE);
                }
                else if(esource==saveRuleAndMapfileMenuItem){
                    ruleAndMapFileReaderWriter.doFileAction(WRITE); 
                }
                else if(esource==loadRuleAndMapfileMenuItem){
                    ruleAndMapFileReaderWriter.doFileAction(READ);
                }
                else if(esource==saveMIDIfileMenuItem){
                    MIDIFileWriter.doFileAction(WRITE);
                }
                
                else if(esource==instrumentsHelpMenuItem){

			HelpWin helpwin = new HelpWin(HelpWin.INSTRUMENTSHELP);
                	helpwin.showHelp();

                }
                else if(esource==symbolsHelpMenuItem){

			HelpWin helpwin = new HelpWin(HelpWin.SYMBOLSHELP);
                	helpwin.showHelp();
  
                }
                else if(esource==LMUSeInfoMenuItem){
                	String LMUSeInfoString="LMUSe\nVersion .9";
                        JOptionPane.showMessageDialog(null,LMUSeInfoString,"LMUSe Info",JOptionPane.PLAIN_MESSAGE);
                	
                }
                else if(esource==instrumentsToTracksMenuItem){
                	midiframe.separateInstrumentTracks=midiframe.separateInstrumentTracks ? false:true;
                	if(midiframe.separateInstrumentTracks){
                	     instrumentsToTracksMenuItem.setText("*Save Instruments on Separate Tracks");
                	}
                	else{
                	     instrumentsToTracksMenuItem.setText("Save Instruments on Separate Tracks");
                	}
                }
        }
        
        
        void ruleFileBufferedRead(BufferedReader in){
             boolean keepGetting=true;
	     String inLine;
             fileText="";
	     int linenum=0;
	     boolean inrules=false;
	     String rulesText="";
	     String axiom=null;

	     while(keepGetting){
	     
        	     try {
                        inLine = in.readLine();
                        if(inLine==null){
                            keepGetting=false;
                            break;
                        }
                        
                     } 
                     catch(IOException e) {
                           System.err.println("readLine() unsuccessful");
                           keepGetting=false;
                           break;
                     }
                     inLine=LTools.formatLineIn(inLine);
                     int eqidx=inLine.indexOf('='); 
                     if(inLine.length()>0){
                     
                             
			     if(inLine.charAt(0)=='@'){
                                      keepGetting=false;
                                      break;
                             }
                             linenum++;
         		     if(linenum==1){
                                     try{
                                          double r=Double.parseDouble(inLine);
                                          numRecursions=(int)r;
                                          if(numRecursions<0) numRecursions=0;
                                     }
                                     catch(NumberFormatException e){
                                     	// if this line is not a number,
                                     	// see if it is a numerical definition
                                     	double p1=LTools.expressionParser.getValu(inLine);
                                     	if(eqidx>0){                                     	    
                                     	    linenum--;
                                     	}
                                     	else{
                                     	     numRecursions=(int)p1;
                                     	}
                                     	
                                     }
                             }
                             else if(linenum==2){
                                    try{
                                          basicAngle=Double.parseDouble(inLine);

                                     }
                                     catch(NumberFormatException e){
                                        // if this line is not a number,
                                     	// see if it is a numerical defintion
                                     	double p1=LTools.expressionParser.getValu(inLine);
                                     	if(eqidx>0){
                                     	    
                                     	    //System.out.println(p1);
                                     	    linenum--;
                                     	}
                                     	else{
                                     		basicAngle=p1;
                                     	}
                                     }
                             }
                             else if(linenum == 3){
                                     try{
                                          basicThickness=Double.parseDouble(inLine);

                                     }
                                     catch(NumberFormatException e){
                                        // if this line is not a number,
                                     	// see if it is a numerical defintion
                                     	double p1=LTools.expressionParser.getValu(inLine);
                                     	if(eqidx>0){
                                     	    
                                     	    //System.out.println(p1);
                                     	    linenum--;
                                     	}
                                     	else{ 
                                     	   if(LTools.expressionParser.isAVariableName(inLine)){
                                     	      basicThickness=p1;
                                     	   }
                                     	   else{////must be the axiom
                                              axiom=inLine;
                                              inrules=true;
                                           }
                                        }
                                     }  
                
                             }
                             
                             else{
                                if(inrules){
                                   if(inLine.charAt(0)=='@'){
                                      keepGetting=false;
                                      break;
                                   }
                                   else if(eqidx>0){
                                      rulesText+=inLine+"\n";
                                   }
                                   else{
                                   
                                   }
                                   
                                }
                                else{
                                    // if this line is not a rule,
                                    // see if it is a numerical defintion                                     	
                                     if(eqidx>0){
                                     	    double p1=LTools.expressionParser.getValu(inLine);
                                     	    //System.out.println(p1);
                                     	    //linenum--;
                                     }
                                     else{//if its not a rule or a number
                                        axiom=inLine;
                                        inrules=true;
                                     }
                                }
                             }
                         
                             fileText+=inLine+"\n";
                     }
                     
	     }
	     if(axiom!=null)
	     	productionframe.setAxiomText(axiom);
	     if(rulesText.length()>0){
	        productionframe.setRules(rulesText);
	        productionframe.disableMutateUndo();
	     }
	     productionframe.setNumRecursions(numRecursions);
	     productionframe.fillDeclareBox();
	     interpretframe.setBasicAngle(basicAngle);
	     interpretframe.setBasicThickness(basicThickness);
	     productionframe.reInit();
	     
        }
	boolean ruleFileWrite(FileWriter fw, boolean withHeaderComments){
	
                String axiomstr=productionframe.getAxiomText();
                Vector declaresV=LTools.expressionParser.getVList();
                String rulesText=productionframe.getRulesText();
                try{
                        if(withHeaderComments){
        	            fw.write("# LMUSe (Java version) L-system Rules file\r\n");
        	 	    fw.write("# Saved: "+new Date().toString()+"\r\n");
        	 	}
        	 	
        	 	if(declaresV.size()>0){
        	 	        fw.write("# Declared constants:\r\n");
        	 		for(int i=0;i<declaresV.size();i++){
        	 		   fw.write((String)declaresV.get(i)+"\r\n");        	 		   
        	 		}
        	 	}
        	 	fw.write("# number of recursions:\r\n");
        		fw.write(productionframe.getNumRecursions()+"\r\n");
        		fw.write("# default angle:\r\n");
        		fw.write(interpretframe.getBasicAngle()+"\r\n");
        		fw.write("# thickness:\r\n");
        		fw.write(interpretframe.getBasicThickness()+"\r\n");
        		fw.write("# axiom:\r\n");
        		fw.write(axiomstr+"\r\n");
        		fw.write("# transformation rules:\r\n");
        		fw.write(rulesText+"\r\n");
        		fw.write("@");
        		
		}catch (Exception e){return false;}
		return true;
	
	}
        boolean readRuleFile(File f){
	     
	     BufferedReader in;
	     
	     try{
                in=new BufferedReader(new FileReader(f)); 
             }catch(Exception e){return false;}
             
	     ruleFileBufferedRead(in);
	     
	     try{
                in.close();
             }catch(Exception e){return false;}
	     
	     return true;
	}

	boolean saveRuleFile(File f){
		boolean ret=true;
		FileWriter fw;
                try{
                	fw=new FileWriter(f); 
                }catch(Exception e){return false;}
                
		if(!ruleFileWrite(fw, true)){
			ret=false;
		}
		
		try{
			fw.close();
		}catch(IOException ioe){}
		return ret;
	}
	boolean readMapFile(File f){
        	BufferedReader in;

        	try{
                        in=new BufferedReader(new FileReader(f)); 
                }catch(Exception e){return false;}
        	
        	interpretframe.mapFileBufferedRead(in);
        
        	try{
                	in.close();
             	}catch(Exception e){return false;}
        	return true;
        }
	boolean writeMapFile(File f){
	 	FileWriter fw;
	 	boolean ret=true;
                try{
                   fw=new FileWriter(f); 
                }catch(Exception e){return false;}
	 	ret = interpretframe.mapFileWrite(fw, true);
	 	try{
	 	   fw.close();
	 	}
	 	catch(Exception e){return false;}
	 	return ret;
	 
	}
	boolean writeRuleAndMapFile(File f){
	 	FileWriter fw;
	 	boolean ret=true;
                try{
                   fw=new FileWriter(f); 
                }catch(Exception e){return false;}
                try{
	 		fw.write("# LMUSe (Java version) L-system Rule w/ Map file\r\n");
	 		fw.write("# Saved: "+new Date().toString()+"\r\n");
	 	}catch(Exception e){return false;}
	 	ret=ruleFileWrite(fw, false);
	 	try{
	 		fw.write("\r\n\r\n");
	 		
	 		
	 	}catch(Exception e){return false;}
	 	if(ret){
	 	   
	 	   ret = interpretframe.mapFileWrite(fw,false);
	 	}
	 			 	
	 	try{
	 	   fw.close();
	 	}
	 	catch(Exception e){return false;}
	 	return ret;
	 
	}
	boolean readRuleAndMapFile(File f){
	     
	     BufferedReader in;
	     
	     try{
                in=new BufferedReader(new FileReader(f)); 
             }catch(Exception e){return false;}
             
	     ruleFileBufferedRead(in);
	     interpretframe.mapFileBufferedRead(in);
	     try{
                in.close();
             }catch(Exception e){return false;}
	     
	     return true;
	}

	
	boolean writeMIDIFile(File f){
	        midiframe.saveMidiFile(f);
		return true;
	}


	static final int READ=0,WRITE=1;
	abstract class LFileReaderWriter{
	        
		String mylastopenName=null;
		File mylastopen=null;
		ExampleFileFilter myfilefilter;		
		String defaultExt=null;
		
		public LFileReaderWriter(ExampleFileFilter ff){
			myfilefilter=ff;
		}
		public LFileReaderWriter(ExampleFileFilter ff, String dE){
			myfilefilter=ff;
			defaultExt=dE;
		}

		abstract boolean myReader(File file);
		abstract boolean myWriter(File file);
		abstract void followup();
	
		void doFileAction(int rOrW){
		// get a file via a file selector dialog, read or write
	        // the file, and remember what file of this
	        // instance's type was last successfully read/written
		    JFileChooser c;
                    if(mylastopenName==null)                 
                        c = new JFileChooser(curDir);
                    else{ 
                    	c = new JFileChooser(mylastopenName);
                    	c.setSelectedFile(mylastopen);
                    }
                    c.addChoosableFileFilter(myfilefilter);
                    int rVal= c.showOpenDialog(null);
                    if(rVal == JFileChooser.APPROVE_OPTION) {
                              boolean successful=false;	
                              File file=c.getSelectedFile();
                              if(rOrW==READ){
                                 successful=myReader(file);
                              }
                              else if(rOrW==WRITE){
                                 int okToWrite=0; 
                                 String fp=file.getPath();
                                 if(file.exists()){
                                     
                                     okToWrite=JOptionPane.showConfirmDialog(null,  "File already exists. OK to overwrite it?",fp, JOptionPane.YES_NO_OPTION);
                                 }
                                 else{
                                    if(defaultExt!=null){
                                      
                                      String fn=file.getName();
                                      // add def extension if this name
                                      // doesn't contain  '.'
                                      int periodplace=fn.indexOf(".");
                                      
                                      if(periodplace<0){
                                      	 fn=addDefaultExtension(fn);
                                      	 
                                      	 file=new File(fn);
                                      	 if(file.exists()){
                                             fp=file.getPath();
                                             okToWrite=JOptionPane.showConfirmDialog(null,  "File already exists. OK to overwrite it?",fp, JOptionPane.YES_NO_OPTION);
                                         }
                                      }
                                          
                                    }
                                    
                                 }
                                 if(okToWrite==0)
                                     successful=myWriter(file);
                              }
			      if(successful){
                                mylastopenName=file.getPath();
                                mylastopen=file; 
                                followup(); 
                                //System.out.println(mylastopenName);                                 
                              }
                     }
                     if(rVal == JFileChooser.CANCEL_OPTION) {
                         
                     }                  
		}

		String addDefaultExtension(String filename){
		        if(defaultExt!=null){
				return filename+"."+defaultExt;
			}
			return filename;
		}
	
	}

	
}


