import java.util.*;



class Mutator{
        
        // share a random number generator:
        static Random prng=new Random(System.currentTimeMillis());
        
        public boolean gotUndo=false;
        
        private int numrules;
        private Object[] hold;// all changes are done on a copy of the rules
        private Object[] undoHold;
        
        synchronized Vector do_mutation(Vector RV, int t, int numM){
		numrules=RV.size();
        	if(numrules==0) return RV;
        	hold=RV.toArray();
        	
        	Object[] tempundo=RV.toArray();
        	boolean mret=false;
        	for (int i=0;i<numM;i++){
        		if(t==0){
                	        int t1=prng.nextInt(5)+1;
                	        mret=mutateSwitch(t1);
			}                	        	
                	 
                	else {
                		mret=mutateSwitch(t);
                	}
        	}
                if(mret){
                	// rebuild the rule table:
                	Rule.reinit();                                
                        RV.removeAllElements();
                        for(int i=0;i<numrules;i++){
                                RV.add(  Rule.stringToRule(((Rule)hold[i]).ruleString)   );                	
                        }
                        undoHold=tempundo;
                        gotUndo=true;
                }
                return RV;
        	
        }
        
        synchronized Vector getUndo(Vector RV){
              if(undoHold==null) return RV;
              if(undoHold.length>0 && gotUndo){
        	Rule.reinit();                                
                RV.removeAllElements();
                for(int i=0;i<undoHold.length;i++){
                        RV.add(  Rule.stringToRule(((Rule)undoHold[i]).ruleString)   );
                }
                gotUndo=false;
              }
              return RV;
        }
        
        private boolean mutateSwitch(int t){
        	boolean ret=false;
        	switch(t){
                		case 1:
                			ret=mutate1();
                			break;
                		case 2:
                			ret=mutate2();
                			break;
                		case 3:
                			ret=mutate3();
                			break;        
                		case 4:
                                	ret=mutate4();
                                	break;	
                                
                                case 5:
                                	ret=mutate5();
                                	break;
                                
                                default: ret=false;
                }
                return ret;
        }
        private boolean mutate1(){
	 // shuffle replacements among keys
                
                int r1=prng.nextInt(numrules);
                int r2=prng.nextInt(numrules);
                if(r1==r2) return false;
                Rule rule1= (Rule)hold[r1];
		Rule rule2= (Rule)hold[r2];
                String L1=Rule.getLeft(rule1);
                String R1=Rule.getRight(rule1);
                String L2=Rule.getLeft(rule2);
                String R2=Rule.getRight(rule2);;

                hold[r1]=Rule.stringToRule(L1+"="+R2);
                hold[r2]=Rule.stringToRule(L2+"="+R1);
                
                return true;
	}
        private boolean mutate2(){
	        // insert a randomly picked rule key into a rule's right side
                
                String toInsert=randomRuleKey();
                
                int rndbrck=prng.nextInt(3);
                switch(rndbrck){
                    case 0:
                        
                        break;
                    case 1:
                        toInsert="["+toInsert+"]";
                        break;
                    case 2:
                        toInsert="{"+toInsert+"}";
                        break;
                }
                int r1=prng.nextInt(numrules);
                     
                Rule rule1= (Rule)hold[r1];
		     
                String L1=Rule.getLeft(rule1);
                String R1=Rule.getRight(rule1);
                
                StringBuffer rBuf=new StringBuffer(R1);
                int ipnt=randomGoodSplitPoint(rBuf);
                if(ipnt==rBuf.length())
                    R1=rBuf.toString()+toInsert;
                else if(ipnt==0)
                    R1=toInsert+rBuf.toString();
                else
                    R1=rBuf.substring(0,ipnt)+toInsert+rBuf.substring(ipnt,rBuf.length());
                
                hold[r1]=Rule.stringToRule(L1+"="+R1);

                return true;
                
	}
        private boolean mutate3(){
		// exchange random fragments among rule right sides
                
                int r1=prng.nextInt(numrules);
                int r2=prng.nextInt(numrules);
                if(r1==r2) return false;
                Rule rule1= (Rule)hold[r1];
		Rule rule2= (Rule)hold[r2];
                String L1=Rule.getLeft(rule1);
                String R1=Rule.getRight(rule1);
                String L2=Rule.getLeft(rule2);
                String R2=Rule.getRight(rule2);;
                
                StringBuffer r1Buf=new StringBuffer(R1);
                int ipnt1=randomGoodSplitPoint(r1Buf);
                int ipnt2=randomGoodSplitPoint(r1Buf);
                if(ipnt2<ipnt1){
                   int h=ipnt2;
                   ipnt2=ipnt1;ipnt1=h;
                }
                
                StringBuffer r2Buf=new StringBuffer(R2);
                int ipnt3=randomGoodSplitPoint(r2Buf);
                
                int ipnt4=randomGoodSplitPoint(r2Buf);
                if(ipnt4<ipnt3){
                   
                   int h=ipnt4;
                   ipnt4=ipnt3;ipnt3=h;
                   
                }
                String sub1=R1.substring(ipnt1,ipnt2);
                String sub2=R2.substring(ipnt3,ipnt4);
                
                //System.out.println(R1.substring(0,ipnt1)+"***"+sub1+"***"+R1.substring(ipnt2,R1.length()));
                //System.out.println(R2.substring(0,ipnt3)+"***"+sub2+"***"+R2.substring(ipnt4,R2.length()));               
 
                R1=R1.substring(0,ipnt1)+sub2+R1.substring(ipnt2,R1.length());
                R2=R2.substring(0,ipnt3)+sub1+R2.substring(ipnt4,R2.length());
 
                hold[r1]=Rule.stringToRule(L1+"="+R2);
                hold[r2]=Rule.stringToRule(L2+"="+R1);
                
                return true;
	}
	private boolean mutate4(){
	// reverse directions
	        //pick a random rule
		int r1=prng.nextInt(numrules);                                
                Rule rule1= (Rule)hold[r1];
                String R1=Rule.getRight(rule1);
                String L1=Rule.getLeft(rule1);
                StringBuffer rBuf1=new StringBuffer(R1);
		int len=rBuf1.length();
		boolean didsomething=false;
		//
		int level=0;
	     	
		for (int j=0;j<len;j++){
		        // look at each symbol
                        char c=rBuf1.charAt(j);
                        // don't alter symbols inside ()'s
                        if(c=='(') level++;
                        else if(c==')') level--;                        
                        if(level>0) 
                        	continue;
                        // for this symbol, apply a random reversal
                        switch (prng.nextInt(12)) {
                          default:
                            didsomething=false; 
                            break;
                          case 0:
                            if (c == '+') {                                
                                rBuf1.replace(j,j,"-");
                                didsomething=true;
                                
                            }
                            break;
                          case 1:
                            if (c == '-') {
                                rBuf1.replace(j,j,"+");
                                didsomething=true;
                            }
                            break;
                          case 2:
                            if (c== '&') {
                                rBuf1.replace(j,j,"^");                                
                                didsomething=true;
                            }
                            break;
                          case 3:
                            if (c == '^') {                                
                                rBuf1.replace(j,j,"&");
                                didsomething=true;
                            }
                            break;
                          case 4:
                            if (c == '>') {
                                rBuf1.replace(j,j,"<");                                
                                didsomething=true;
                            }
                            break;
                          case 5:
                            if (c== '<') {
                                rBuf1.replace(j,j,">");
                                didsomething=true;
                            }
                            break;
                          case 6:
                            if (c == '|') {
                                rBuf1.replace(j,j,"%");                                
                                didsomething=true;
                            }
                            break;
                          case 7:
                            if (c == '%') {
                                rBuf1.replace(j,j,"|");                                
                                didsomething=true;
                            }
                            break;
                          case 8:
                            if (c == ':') {
                                rBuf1.replace(j,j,";");                                
                                didsomething=true;
                            }
                            break;
                          case 9:
                            if (c == ';') {                                
                                rBuf1.replace(j,j,":");
                                didsomething=true;
                            }
                            break;
                          case 10:
                            if (c == '\'') {                                
                                rBuf1.replace(j,j,"\"");
                                didsomething=true;
                            }
                            break;
                          case 11:
                            if (c == '\"') {                                
                                rBuf1.replace(j,j,"\'"); 
                                didsomething=true;
                            }
                            break;
                        }
                }
             
                if(didsomething)
                    hold[r1]=Rule.stringToRule(L1+"="+rBuf1.toString());

                return didsomething;
        }
        private boolean mutate5(){
		// switch some push/pop commands
                
                int r1=prng.nextInt(numrules);
                
                
                Rule rule1= (Rule)hold[r1];
		
                String L1=Rule.getLeft(rule1);
                String R1=Rule.getRight(rule1);
                
                StringBuffer r1Buf=new StringBuffer(R1);
                
                int len=r1Buf.length();
                if(len<=0) return false;
                int startpt=prng.nextInt(len);
                char c=r1Buf.charAt(startpt);
                int leftb=-1,rightb=-1;
                char a=0,b=0;
                int i=startpt;
                while (i>=0){
                
                	c=r1Buf.charAt(i);
                	if(c=='{'||c=='['||c=='\\'){
                		a=c;
                		leftb=i;
                		break;	
                	}
                	i--;
                }
                if(leftb<0){
                	return false;
                }
                if(a=='{')       b='}';
                else if(a=='[')  b=']';
                else if(a=='\\') b='/';
                i=leftb+1;
                int level=0;
                while (i<len){
                        
                	c=r1Buf.charAt(i);
                	if(c==a){
                		level++;		
                	}
                	else if(c==b && level==0){
                		rightb=i;
                		break;
                	}
                	else if(c==b){
                		level--;
                	}
                	i++;
                }
                if(rightb<0){
                	return false;
                }
                if(a=='{'){
                	a=(prng.nextInt(2)==0)?'[':'\\';
                }
                
                else if(a=='['){
                	a=(prng.nextInt(2)==0)?'{':'\\';
                }
                else if(a=='\\'){
                	a=(prng.nextInt(2)==0)?'[':'{';
                }
                String astr;
                String bstr;
                if(a=='{')       {astr="{";bstr="}";}
                else if(a=='[')  {astr="[";bstr="]";}
                else             {astr="\\";bstr="/";}
                r1Buf.replace(leftb,leftb+1,astr); 
                r1Buf.replace(rightb,rightb+1,bstr); 
                
		//System.out.println(5);                
                
                hold[r1]=Rule.stringToRule(L1+"="+r1Buf.toString());

                
                return true;
	}
        

	String randomRuleKey(){
	// return a randomly picked rulekey from the key hashmap
	        Set rulekeys=Rule.rules.keySet();
                int rksize=rulekeys.size();
                if(rksize==0) return null;
                int keyindex=prng.nextInt(rksize);
                Iterator it=rulekeys.iterator();
                                
                String key=(String)it.next();
                int i=0;
                while (i<keyindex){
                    key=(String)it.next();
                    i++;
                }
                return key;
	}

	private int randomGoodSplitPoint(StringBuffer sb){
	// returns 'ipnt', some index into sb for which
	// sb.substring(0,ipnt) or sb.substring(ipnt,sb.length()) does
	// not break a numerical expression
		int blen=sb.length();
		if(blen==0) return 0;
		int ipnt=prng.nextInt(blen);
		//if(ipnt==blen-1)return ipnt;
		int i;
		int level=0;
		char c1=0,c2=0;
		for(i=0;i<ipnt;i++){ // walk into the buffer to ipnt,
		                       // watching the numerical expressions
		     c1=sb.charAt(i);
		     if(c1=='(') level++;
		     else if(c1==')') level--;
		}
		
                //  01234567
		//  ABC(.5)X
		//        ^ 
		//  ABC(.5)X
		//     ^ 
		//  ABC(.5)X
		//       ^ 

		while( ipnt<blen && level>0 ){
		// if we are inside ()'s, keep going until we are out
		     c1=sb.charAt(ipnt);
		     if(c1=='(') level++;
		     else if(c1==')') level--;
		     ipnt++;
		}
		//  ABC(.5)X
		//         ^
                //  ABC(.5)X
		//     ^
		//  ABC(.5)X
		//         ^ 

		if(ipnt<blen)
		   c2=sb.charAt(ipnt);
		else return ipnt;
		//  ABC(.5)X
		//        12
                //  ABC(.5)X
		//     12
		//  ABC(.5)X
		//        12 
		//  ABC.54X
		//    12
                //  ABC.54X
		//     12
		//  ABC.54X
		//       12 

		while(
        		((c1<='9'&&c1>='0') || c1=='.')
        		&&
        		((c2<='9'&&c2>='0') || c2=='.')
        		&&
        		ipnt<blen
		){
		   c1=sb.charAt(ipnt);
		   ipnt++;
		   if(ipnt<blen)
		      c2=sb.charAt(ipnt);
		   else break;
		}
		//System.out.println(sb.charAt(ipnt));
		
		return ipnt;
	
	}
}