import java.util.*;


public class Vector3{
	
        static final double eqEpsilon=.00001;
        static final Vector3 Sky=new Vector3(0,1,0);
	static final Vector3 X=new Vector3(1,0,0);
	static final Vector3 Y=new Vector3(0,1,0);
	static final Vector3 Z=new Vector3(0,0,1);
	
        public double   x,
			y,
			z;
	// constructor
	public Vector3(){
	
	}
	public Vector3(Vector3 v){
	    x=v.x;y=v.y;z=v.z;
	}

	public Vector3(double x, double y, double z){
		this.x = x;
		this.y = y;
		this.z = z;
	}
	public void copy(Vector3 toCopy){
		// set this vectors components equal to those of the argument
		x=toCopy.x;
		y=toCopy.y;
		z=toCopy.z;
	}
	// instance method
	public void normalize(){
		double abs = Math.sqrt(x*x + y*y + z*z);
		x=x/abs;
		y=y/abs;
		z=z/abs;
	}
	double abs(){
	        return Math.sqrt(x*x + y*y + z*z);
	}
        void xRot(double theta){
                double vx=x,vy=y,vz=z;
                x = vx;
                y = vy * Math.cos(theta) - vz * Math.sin(theta);
                z = vz * Math.cos(theta) + vy * Math.sin(theta);
        }
        void yRot(double theta){        	
                double vx=x,vy=y,vz=z;
                x = vx * Math.cos(theta) + vz * Math.sin(theta);
                y = vy;
                z = vz * Math.cos(theta) - vx * Math.sin(theta);		
        }
        void zRot(double theta){
                double vx=x,vy=y,vz=z;
                x = vx * Math.cos(theta) + vy * Math.sin(theta);
                y = vy * Math.cos(theta) - vx * Math.sin(theta);
                z = vz;
        }
        void reverse(){
                x=-x;y=-y;z=-z;
        }
        boolean isEqual(Vector3 v){
                double dx=v.x-x, dy=v.y-y, dz=v.z-z;

                return Math.sqrt(dx*dx+dy*dy+dz*dz)<eqEpsilon;
        }
        Vector3 rotate (Vector3 about , double a){
                    /*rotate 'this' around 'about' by angle a*/
        
                    double aboutx=about.x, abouty=about.y, aboutz=about.z,
                           vx=x, vy=y, vz=z;
                    double ac, bc, cc, cosa, sina, gz;
                    double R11,R12,R13,R21,R22,R23,R31,R32,R33;
                    double aboutlen = Math.sqrt(aboutx*aboutx + abouty*abouty + aboutz*aboutz);
                    ac = aboutx/aboutlen;
                    bc = abouty/aboutlen;
                    cc = aboutz/aboutlen;
                    cosa = Math.cos(a); sina = Math.sin(a);
                    gz = 1 - cosa;
		    // a 'matrix'        
                    R11 = ac*ac*gz + cosa;    R12 = ac*bc*gz - cc*sina; R13 = ac*cc*gz + bc*sina;
                    R21 = ac*bc*gz + cc*sina; R22 = bc*bc*gz + cosa;    R23 = bc*cc*gz - ac * sina;
                    R31 = ac*cc*gz - bc*sina; R32 = bc*cc*gz + ac*sina; R33 = cc*cc*gz + cosa;
        
                    double wx = R11*vx + R12*vy + R13*vz;
                    double wy = R21*vx + R22*vy + R23*vz;
                    double wz = R31*vx + R32*vy + R33*vz;
	    	    return new Vector3(wx,wy,wz); 	
	}

        static double deg2rad (double deg){
            return (Math.PI * deg / 180.0);
        }
        
        Vector3 cross(Vector3 w){
            /* return: this X w*/            
            Vector3 retV = new Vector3();
            retV.x = y * w.z - z * w.y;
  	    retV.y = z * w.x - x * w.z;
  	    retV.z = x * w.y - y * w.x;
  	    return retV;
        }        
        double dot(Vector3 w){
        	return x*w.x + y*w.y + z*w.z;
        }
        public String toString(){
                return (String)"<"+x+", "+y+", "+z+">";
        }
       
}

